﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using ReflectionIT.Minesweeper;
using System.Windows.Browser;

namespace Minesweeper {
    public partial class Page : UserControl {

        private Game _game;

        private const int size = 10;

        public Page() {
            InitializeComponent();

            _game = (Game)this.Resources["GameboardDS"];
            _game.Init(field, 10, 10, 10);
            _game.Setup();
            _game.GameOver += new EventHandler(_game_GameOver);

            this.DataContext = _game;

            HtmlPage.Document.AttachEvent("oncontextmenu", this.OnContextMenu);
        }

        void _game_GameOver(object sender, EventArgs e) {
            if (_game.Won) {
                (FindName("media2") as MediaElement).Play();
                (FindName("Storyboard1") as Storyboard).Begin();
            } else {
                (FindName("media") as MediaElement).Play();
                (FindName("Storyboard2") as Storyboard).Begin();
            }
        }

        private void ButtonStart_Click(object sender, RoutedEventArgs e) {
            _game.Setup();
        }

        private void OnContextMenu(object sender, HtmlEventArgs e) {
            if (_game.RightMouseClick(e.OffsetX, e.OffsetY)) {
                e.PreventDefault();
            }
        }
    }
}
